//---------------------------------------------------------------------------

//BT Car
//Program pro ovldn modelu auta pomoc Bluetooth
//vce informac na petrgabrlik-email.cz www.pier.own.cz

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Tserial_event.h"
#include <string.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
Tserial_event serial_port;

int comnum;
char comnumstr[5];

void SerialEventManager(uint32 object, uint32 event)
{
    char *buffer;
    int   size,data;
    Tserial_event *com;
    char   txt[512];

    com = (Tserial_event *) object;
    if (com!=0)
    {
        switch(event)
        {
            case  SERIAL_CONNECTED  :
                                        Form1->Label2->Font->Color = clGreen;
                                        Form1->Label2->Caption = (AnsiString("PIPOJENO"));
                                        Form1->Label3->Caption = ("VYPNUTA");
                                        Form1->Label3->Font->Color = clRed;
                                        Form1->Butt_connect->Enabled = False;
                                        Form1->Butt_disconnect->Enabled = True;
                                        break;
            case  SERIAL_DISCONNECTED  :
                                        Form1->Label2->Font->Color = clRed;
                                        Form1->Label2->Caption = (AnsiString("ODPOJENO"));
                                        Form1->Label3->Caption = ("VYPNUTA");
                                        Form1->Label3->Font->Color = clRed;
                                        Form1->Butt_connect->Enabled = True;
                                        Form1->Butt_disconnect->Enabled = False;
                                        break;
            case  SERIAL_DATA_SENT  :
                                        break;

            case  SERIAL_DATA_ARRIVAL  :
                                        size   = com->getDataInSize();
                                        buffer = com->getDataInBuffer();

                                        if (size>511)
                                            size=511;

                                        memcpy(txt,buffer, size);
                                        txt[size] = 0;

                                        data = StrToInt(txt);

                                        if (data==6)
                                        {Form1->Label3->Caption = ("ZAPNUTA");
                                         Form1->Label3->Font->Color = clGreen;
                                        }

                                        if (data==7)
                                        {Form1->Label3->Caption = ("VYPNUTA");
                                         Form1->Label3->Font->Color = clRed;
                                        }

                                        com->dataHasBeenRead();
                                        break;
        }
    }
}


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
    Form1->Butt_disconnect->Enabled = False;
    serial_port.setManager(SerialEventManager);
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
void __fastcall TForm1::pripojit(TObject *Sender)
{
        // CONNECT
        serial_port.connect("COM3",9600,SERIAL_PARITY_NONE,8,false);
        serial_port.sendData("7", 1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::odpojit(TObject *Sender)
{
        // DISCONNECT
        serial_port.sendData("7", 1);
        serial_port.disconnect();       //disconnect
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
//--OVLDN-----------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Butt_vpredClick(TObject *Sender)
{
        serial_port.sendData("0", 1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Butt_vzadClick(TObject *Sender)
{
        serial_port.sendData("1", 1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Butt_vpred_vlevoClick(TObject *Sender)
{
        serial_port.sendData("3", 1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Butt_vpred_vpravoClick(TObject *Sender)
{
        serial_port.sendData("2", 1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Butt_vzad_vlevoClick(TObject *Sender)
{
        serial_port.sendData("5", 1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Butt_vzad_vpravoClick(TObject *Sender)
{
        serial_port.sendData("4", 1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Butt_svetla_onClick(TObject *Sender)
{
        serial_port.sendData("6", 1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Butt_svetla_offClick(TObject *Sender)
{
        serial_port.sendData("7", 1);
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Butt_infoClick(TObject *Sender)
{
        serial_port.disconnect();       //disconnect
        Form2->Show();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Butt_svetla_onKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
                serial_port.sendData("6", 1);
}
//---------------------------------------------------------------------------

